\section{Formatting Rules}
\subsection{(*) Fonts}\label{fonts}

If you are not using a text mode editor, coding is much easier with a
fixed pitch font. Otherwise you cannot benefit from using tabulators
($\rightarrow$ \ref{tab}) and reading the code will be difficult. To
demonstrate the difference an example with a fixed pitch font and one
without is shown in figure \ref{fig:fontexamples}.
\begin{figure}[htb]
	\begin{center}
		\begin{tabular}{p{0.45\linewidth}p{0.45\linewidth}}
		\begin{lstlisting}
p_clock_generator: process
begin
  if (reset_n_i = '0') then
    s_clk <= '1';
  else
    wait for g_PERIOD/2;
    if s_clk = '0' then
      s_clk <= '1';
    else
      s_clk <= '0';
    end if;
  end if;
  clk_o <= s_clk;
end process p_clock_generator;\end{lstlisting}
&
\begin{lstlisting}[flexiblecolumns=true, columns=fullflexible, 
							basewidth=0.45em, basicstyle=\normalfont\footnotesize]
p_clock_generator: process
begin
  if (reset_n_i = '0') then
    s_clk <= '1';
  else
    wait for g_PERIOD/2;
    if s_clk = '0' then
      s_clk <= '1';
    else
      s_clk <= '0';
    end if;
  end if;
  clk_o <= s_clk;
end process p_clock_generator;\end{lstlisting}\\[-5ex]
			\begin{center}
				good example
			\end{center}
		& 
			\begin{center}
				bad example
			\end{center}\\[-5ex]
		\end{tabular}
	\end{center}
	\caption{Font examples}
	\label{fig:fontexamples}
\end{figure}
\subsection{(x) Line Width}\label{linewidth}

The line length of the code should not exceed 80 characters. Many
editors cannot handle longer lines or you may get in trouble when
printing out the source file. Remember that there may be other
programmers who would want to take look at your code!

Because 80 characters are rather few, maximum of 100 characters is
suggested instead. With common graphical editors it is possible to
find a fixed font ($\rightarrow$ \ref{fonts}) and an appropriate size
to print the code out without a line break. No matter which line width
you decide to use, no line should exceed the screen width. Otherwise
it is very hard to read the code. To further improve readability, each
line should contain one statement at maximum.  \clearpage

\subsection{(*) Tabulators}\label{tab}

Don't use so called ``hard tabulators'' because each editor (and
printer as well) can have a different width assigned to them. Because
each user uses a different editor (or printer) somebody might have
problems reading your code easily.

For better readability use so called ``soft tabulators'', which is
nothing else than a sequence of spaces. Every editor (or printer) is
able to display this correctly. It is recommended to use soft
tabulators with an equivalent of 2 spaces, but you can also use 2-4
spaces. The more spaces you use the easier it is to find blocks in
your code, however you may run into troubles with the line width
($\rightarrow$ \ref{linewidth}).

\subsection{(*) File Header}\label{Header}

Each file in your design should contain a standardised header, where
important information about the file content is stored. Further, this
header should improve readability and maintenance of your project. It
should provide all information you need to handle your code in a
convenient way. For more details refer to figure \ref{fig:header}.

\begin{figure}[htb]
	\begin{lstlisting}
-------------------------------------------------------------------------------
--                                                                           --
--            company name, division and the name of the design              --
--                                                                           --
-------------------------------------------------------------------------------
--  
--     unit name: <full name> (<shortname / entity name>)
--    
--        author: <author name> (<email>)
--
--          date: $Date::                $:
-- 
--       version: $Rev::                 $:
--
--   description: <file content, behaviour, purpose, special usage notes...>
--                <further description>
--
--  dependencies: <entity name>, ...
--
--    references: <reference one>
--                <reference two> ...
--
--   modified by: $Author::              $:
--
-------------------------------------------------------------------------------
--  last changes: <date> <initials> <log>
--                                  <extended description>
-------------------------------------------------------------------------------
--          TODO: <next thing to do>
--                <another thing to do>
--
-------------------------------------------------------------------------------
	\end{lstlisting}
	
	\caption{Standard file header}
	\label{fig:header}
\end{figure}

\subsection{(*) Comments}\label{comments}

As it is true for all programming languages, each important operation
and definition should have a comment above or beside it, describing
operation of the statement. You will make life much easier for someone
who would like to add functionality or fix a bug. Not to mention it is
good for you as well, if you try to change the code after some time.

There are special elements in the code which need extended comments
like the file header ($\rightarrow$ \ref{Header}), entities or
architectures ($\rightarrow$ \ref{EntArchConf}), blocks or processes
($\rightarrow$ \ref{BlockProc}). The following paragraphs show
comments for these elements.

\begin{figure}[htb]
\begin{lstlisting}
--=============================================================================
-- Entity declaration for <long entity name of my_entity>
--=============================================================================
entity my_entity is 
  generic (
    g_MYGENERIC : positive := 32 -- something which has to be configurable
  );                                         
  port (
    -- global input signals
    clk_i     : in    std_logic; -- local bus clock
    reset_n_i : in    std_logic; -- reset =0: reset active
                                 --       =1: no reset              
                                
    -- global output signals
    led_o     : out   std_logic; -- LED =0: LED on
                                 --     =1: LED off                                
                                       
    -- data bus(es)
    data_b    : inout std_logic_vector (7 downto 0) -- data bus
  );
end entity my_entity;
\end{lstlisting}
	\caption{Comments for entities}
	\label{fig:ComEnt}
\end{figure}

\begin{figure}[htb]
\begin{lstlisting}
--=============================================================================
-- architecture declaration
--=============================================================================
architecture rtl of my_entity is

signal s_clk_local : std_logic; -- local clock

--=============================================================================
-- architecture begin
--=============================================================================
begin

end architecture rtl;
--=============================================================================
-- architecture end
--=============================================================================
\end{lstlisting}
	\caption{Comments for architectures}
	\label{fig:ComArch}
\end{figure}

\begin{figure}[htb]
\begin{lstlisting}
--=============================================================================
-- Begin of my_process
-- <description>
--=============================================================================
-- read:  clk_i, reset_n_i
-- write: s_clk_local
-- r/w:   led_o
p_my_process: process (clk_i)
begin
  if (clk_i'event and clk_i = '1') then -- synchronous process
    if reset_n_i = '0' then
      -- reset to default value
      led_o <= '1';
    else
      -- generate clock signal and LED output
      s_clk_local <= not s_clk_local; -- s_clk_local now runs at half of clk_i
      if s_clk_local = '1' then
        led_o <= '0' -- turn on LED if s_lclk is high
      end if;
    end if;
  end if;
end process p_my_process;
\end{lstlisting}
	\caption{Comments for processes}
	\label{fig:ComProc}
\end{figure}

\subsection{(*) Keywords}\label{keywords}

The VHDL-93 keywords are shown in figure \ref{fig:VHDLKeywords}. They
should be written in lower case to distinguish them from user defined
names ($\rightarrow$ \ref{NameStyle}).  Further, you should avoid the
use of keywords in your signal names, entity names etc. Otherwise, you
may get confused about their function when reading these words in your
names or get into trouble with the compiler.  \clearpage

\begin{figure}[htb]
	\begin{lstlisting}[keywordstyle=\color{black}]
abs, access, after, alias, all, and, architecture, array, assert, attribute
begin, block, body, buffer, bus
case, component, configuration, constant
disconnect, downto
else, elsif, end, entity, exit
file, for, function
generate, generic, group, guarded
if, impure, in, inertial, inout, is
label, library, linkage, literal, loop
map, mod
nand, new, next, nor, not, null
of, on, open, or, others, out
package, port, postponed, procedure, process, pure
range, record, register, reject, rem, report, return, rol, ror
select, severity, shared, signal, sla, sll, sra, srl, subtype
then, to, transport, type
unaffected, units, until, use
variable
wait, when, while, with
xnor, xor
	\end{lstlisting}
	
	\caption{VHDL 93 keywords}
	\label{fig:VHDLKeywords}
\end{figure}

\subsection{Syntax Highlighting}

To improve readability of your code you may want to use an editor
which is capable of syntax highlighting. Colour coding the keywords
($\rightarrow$ \ref{keywords}) of VHDL and especially the comments
does help you to keep an overview of the code.


\section{Name Style Rules}\label{NameStyle}

Use only English language for all names given. It simplifies the
transfer of your design to other parties involved. it will often be
convenient to use standard names for signals, like reset or clock,
where it does not make sense to translate them. As a consequence of
this fact, consistency can only be maintained if you use English for
all names. In general, you should avoid any special characters inside
the name of an element because you might run into trouble with the
compiler and/or synthesis tool.

The identifiers can be written in lower and upper case, according to
the rules in the following sections. Nevertheless, all user defined
names must be unique even if they are converted to unicase. Otherwise
you might have troubles with the compiler and/or synthesis tool.

\subsection{(*) Signals, Variables, Constants, Types, Generics, Files}\label{SigVar}

These elements should have names containing only the letters A-Z, a-z,
\_, and 0-9. Do not use any other characters. Writing identifiers (FSM
states, constants, generics) in upper case makes it easier to identify
user defined names in the code. Further, there are different prefixes
and suffixes shown in Table \ref{tab:ExtSig} - obligatory usage and
Table \ref{tab:ExtSigO} - optional usage. They should be used to
clearly identify the type of the user defined name.

It is recommended to use the same signal or generic name through the
whole design hierarchy. This helps you identifying a signal or generic
at a low level which has been set at the top level entity. Further,
you should propagate every generic to the top because so you are able
to configure the whole design in a centralised way.
% RH: this is also possible via configurations, packages, ...

\begin{table}[htb]
	\centering
		\begin{tabular}{lll}
			\toprule
			description							& extension 					& example \\
			\midrule
			variable								& prefix \texttt{v\_}		& \texttt{v\_buffer}\\
			clock										& prefix \texttt{clk\_} & \texttt{clk\_system\_i}\\
			alias										& prefix \texttt{a\_}		& \texttt{a\_bit5}\\
			constant								& prefix \texttt{c\_}		& \texttt{c\_LENGTH}\\
			type definition					& prefix \texttt{t\_}		& \texttt{t\_mytype}\\
			generics								& prefix \texttt{g\_}		& \texttt{g\_WIDTH}\\
			file identifier					& prefix \texttt{fd\_}	& \texttt{fd\_romcontent}\\
			low active signal or variable & suffix \texttt{\_n}		 	& \texttt{s\_reset\_n}\\
			tri-stated signal or variable & suffix \texttt{\_z}			& \texttt{v\_databus\_z}\\
			unit input signals				& suffix \texttt{\_i}		& \texttt{clk\_i}\\
			unit output signals				& suffix \texttt{\_o}		& \texttt{led\_o}\\
			unit bidirectional signals		& suffix \texttt{\_b}		& \texttt{data\_b}\\
			\bottomrule
		\end{tabular}

	\caption{Obligatory extensions}
	\label{tab:ExtSig}
\end{table}

\begin{table}[htb]
	\centering
		\begin{tabular}{lll}
			\toprule
			description							& extension 					& example \\
			\midrule
			internal signal					& prefix \texttt{s\_}		& \texttt{s\_state}\\
			asynchronous signal			& suffix \texttt{\_a}		& \texttt{s\_state\_a}\\
			delayed signal					& suffix \texttt{\_d$n$}	& \texttt{pulse\_d2}\\
			counter signal					& suffix \texttt{\_c}   & \texttt{seconds\_c}\\
%			flag										& suffix \texttt{\_f}		& \texttt{full\_f}\\
%			rising edged signal			& suffix \texttt{\_re}	& \texttt{pulse\_re}\\
			pulse signal					  & suffix \texttt{\_p$n$}		& \texttt{done\_p1}\\
			\bottomrule
		\end{tabular}

	\caption{Optional extensions}
	\label{tab:ExtSigO}
\end{table}

\subsubsection{(x) Origin Based Naming Convention}

If several entities are connected within a larger design, sometimes it
makes sense to use this type of convention, because it eases reading
and understanding of internal connections. The entity port names are
then made up of the entity driving the port (source) and the further
name representing the meaning of the port (\texttt{<entity>\_<further
  port name>}). The suffixes for the direction (\texttt{\_i, \_o,
  \_b}) this way are only needed for the top level ports connected to
pins.

Further, the signals connecting entities are named like the ports. By
using this naming convention, the ports and connecting signals are
named identically throughout the whole design, which makes the code
more readable. E.\,g. \texttt{cpu\_reg\_rden} or
\texttt{uart\_reg\_data}.

\subsection{(*) Blocks, Processes and other Labels}\label{BlockProc}

You are strongly encouraged to use labels for all sequential blocks in
your code. This simplifies reading and analysing log files from the
compiler and/or synthesis tool. Table \ref {tab:ExtBlockProcess} shows
the extensions for blocks, processes and other useful labels. Note
that large blocks are easier to read if the specific label name is not
only used at the beginning of a statement (process, block, generate)
but also in connection with the closing part of a code
block. (e.\,g. end p\_register;)

\begin{table}
	\centering
	\begin{tabular}{lll}
		\toprule
		description		& extension 					& example \\
		\midrule
		process		& prefix \texttt{p\_}		& \texttt{p\_register: process(clk\_i, reset\_n\_i)}\\
		block			& prefix \texttt{b\_}		& \texttt{b\_global\_signals: block}\\
		loop      & prefix \texttt{l\_}		& \texttt{l\_sync\_event: for nr in 3 downto 0 loop}\\
		generate 	& prefix \texttt{gen\_}		& \texttt{gen\_my\_components: generate}\\
		function 	& prefix \texttt{f\_}		& \texttt{function f\_arctan (...)}\\
		component	& prefix \texttt{cmp\_} 	& \texttt{cmp\_my\_component: my\_component\_name}\\
		other labels& none							& \texttt{important\_command:}\\
		\bottomrule
	\end{tabular}
	\caption{Label prefixes for process, blocks, etc.}
	\label{tab:ExtBlockProcess}
\end{table}

\subsection{(*) Entity, Architecture, Configuration}\label{EntArchConf}

The entity name (short name) should describe the functionality of the
block. The name should not count more than 15 characters (letters A-Z,
a-z, \_ and 0-9) because it is reused in the name of a possible
configuration. The full name of the entity should be in the comment
($\rightarrow$ \ref{comments}) above the entity declaration.

An architecture name should be ``behaviour'', ``structure'', or
``rtl'' (register transfer logic), according to description of the
system behaviour. The three parts of an architecture (declaration,
begin, end) should be marked with appropriate comments ($\rightarrow$
\ref{comments}).

A configuration always belongs to one entity and a specific
architecture of this entity. Therefore, the name should represent this
togetherness as it is shown in Table \ref{tab:ExtEntConf}.

\begin{table}
	\centering
	\begin{tabular}{lll}
		\toprule
		description		    & extension 				& example \\
		\midrule
		architecture      & none						& \texttt{behaviour, structure, rtl}\\
		entity simulator	& suffix \texttt{\_sim}	& \texttt{my\_entity\_sim}\\
		entity test bench	& suffix \texttt{\_tb}  & \texttt{my\_entity\_tb}\\
		configuration	    & \textless ent.\textgreater\_\textless arch. \textgreater\texttt{\_cfg} & \texttt{my\_entity\_rtl\_cfg}\\
		\bottomrule
	\end{tabular}
	\caption{Extensions for entities, architectures and configurations}
	\label{tab:ExtEntConf}
\end{table}


\subsection{(x) Files}

File names should always start with the entity name of the
corresponding unit, but for compatibility to different file systems,
only lower case letters should be used for names. If you have
different architectures in separate files you should add a suffix
representing the architecture to the file name. For details about
extensions for files please see Table \ref {tab:ExtFiles}.

Referencing external files within the code should only be done by
giving the \emph{relative} path. If not, you might experience problems
compiling your code on another computer or even directory, which is
often the case when multiple developers work together. Note that using
relative path names is tricky with some tools. Some recognize the
external file relative to the location of the code, including it, and
others relative to the working directory of the tool.

\begin{table}
	\centering
	\begin{tabular}{lll}
		\toprule
		description				& extension 			& example \\
		\midrule
		entity					& none (\texttt{\_})	& \texttt{my\_entity\_.vhd}\\
		architecture rtl			& \texttt{\_rtl}		& \texttt{my\_entity\_rtl.vhd}\\
		architecture structure	& \texttt{\_struc}	& \texttt{my\_entity\_struc.vhd}\\
		architecture behaviour	& \texttt{\_behav}	& \texttt{my\_entity\_behav.vhd}\\
		package					& \texttt{\_pkg}		& \texttt{mypackage\_pkg.vhd}\\
		\bottomrule
	\end{tabular}
	\caption{Extensions for files}
	\label{tab:ExtFiles}
\end{table}

\subsection{(x) Directories}

Directory structure of each hardware design project should separate
files for source code, simulation, test bench, synthesis and
implementation. Figure \ref{fig:hierarchy} shows required directories
hierarchy for a common project.

If multiple testcases are used to simulate the design, the directory
for simulation files (\texttt{sim/gate\_sim} and
\texttt{sim/rtl\_sim}) should provide subdirectories called
\texttt{TC<testcase\_name>}.

\begin{figure}%[!ht]
  \centering
    \includegraphics[viewport = 26 91 765 580]{directory_diagram_rearranged.pdf}
%  \end{center}
  \caption{Project directories hierarchy}
  \label{fig:hierarchy}
\end{figure}

\clearpage
\section{Coding Rules}

\subsection{(*) Notation for Bussed Signals}

There is a need for consistent notation of bussed signals. Use only
MSB to LSB notation (as shown in figure \ref{fig:Buses}) for all
bussed signals, variables and ports to avoid misinterpretation
throughout the design flow.

There is another one, connected to this one. You should not mix
``downto'' and ``to'' for specifying the bus width through your
design. In most cases you will have no problem just using ``downto''.

To indicate that your signal, variable or port is a bus, you should
always specify the range you want to use. Do this even if you use the
full range, where it is not mandatory to clearly mark buses.

\begin{figure}[htb]
	\begin{center}
		\begin{lstlisting}
--=============================================================================
-- Entity declaration for my_entity
--=============================================================================
entity my_entity is 
  port (
    -- global input signals
    clk_i     : in std_logic; -- local bus clock
    reset_n_i : in std_logic; -- reset =0: reset active
                              --       =1: no reset              
    -- data bus(es)
    data_i    : in std_logic_vector (7 downto 0) -- data input
  );
end entity my_entity;

--=============================================================================
-- architecture declaration
--=============================================================================
architecture rtl of my_entity is

constant c_INITIAL  : std_logic_vector (2 downto 0) := "111"; -- initial value
		\end{lstlisting}
	\end{center}
	\caption{Buses}
	\label{fig:Buses}
\end{figure}

\subsection{(x) Bussed Ports Width Rules}

You should not use buses of width one. First of all, it does not make
much sense and second - you may get into troubles during placing and
routing. Another problem is that buses of width one cannot be accessed
with normal bus syntax in all cases. For details about possible issues
please refer to \cite{VHDL01} part 1 / 4.2.4.

Further, only compare buses of the same width, so that comparison
always works properly.

\subsection{(x) Top Level Module Structure}

If your core is complex and has several submodules in hierarchy, it is
recommended that the top level module is used for connectivity only,
without any logic. It makes the design cleaner and gives an instant
insight to major blocks. If you need some glue logic, create a
separate module for that purpose.
 
Further, try as far as possible/reasonable to bring all vendor-specific blocks
to the top level so they can be easily identified if the design needs
to be ported to a different platform. 

\subsection{(x) Component Instantiation}

Components instantiations should be kept together, in the same part of
the code, in order to have a better overview.

There are two ways to instantiate component. Either you choose to
associate the ports by position or by name. Better solution is to use
the latter (see figure \ref{fig:CompInst}) because you don't have to
remember the exact sequence of the ports and you will get an error if
you want to use a non-existent port. Therefore, it is more likely that
the instantiated component is correctly connected.

\begin{figure}[htb]
	declaration:
	\begin{lstlisting}
component my_buffer
  generic (
    g_DEFAULT : std_logic : = '1' -- reset value for buffer
  );
  port (
    input_i   : in  std_logic; -- signal to be double buffered
    output_o  : out std_logic; -- buffered version of the input signal
    clk_i     : in  std_logic; -- buffer clock
    reset_n_i : in  std_logic  -- buffer reset
  );
end component my_buffer;
	\end{lstlisting}
instantiation:
	\begin{lstlisting}
cmp_nCS_buffer: my_buffer
   generic map (
     g_DEFAULT => '1'
   )
   port map (
     clk_i     => clk_i, 
     reset_n_i => s_reset_n, 
     input_i   => cs_n_i, 
     output_o  => s_cs_n
   );
	\end{lstlisting}
	
	\caption{Component declaration and instantiation}
	\label{fig:CompInst}
\end{figure}

\subsection{(*) Reset for Sequential Blocks}

Resets coming from bus lines should always be registered and
deglitched.  Use either a global synchronous or a global asynchronous
reset for all sequential blocks. If there is no particular reason
using the first is recommended. A reset is required because you need a
defined state where you can begin your simulation or where your
hardware starts working. This state is then the same for testing,
debugging and simulation. Therefore you can rely on a consistent
beginning which is not dependent on your compiler, simulator or
synthesis tool. Figure \ref{fig:ProcRst} shows the template of two
synchronous processes, one with synchronous and one with asynchronous
reset.

\begin{figure}[htb]
	\begin{center}
		\begin{tabular}{p{0.45\linewidth}p{0.45\linewidth}}
			\begin{center}
			synchronous
			\end{center}
		& 
			\begin{center}
			asynchronous
			\end{center}\\[-5ex] % remove unecessary veritcal spaces
		\begin{lstlisting}
p_my_process: process (clk_i)
begin
  if (clk_i'event and clk_i = '1') then
    if reset_n_i = '0' then
      -- reset to default
    else
      -- normal operation
    end if;
  end if;
end process p_my_process;\end{lstlisting}
	&
		\begin{lstlisting}
p_my_process: process (clk_i, reset_n_i)
begin
  if reset_n_i = '0' then
    -- reset to default
  elsif (clk_i'event and clk_i = '1') then
    -- normal operation
  end if;
end process p_my_process;\end{lstlisting}\\[-5ex] % remove unecessary veritcal spaces
		\end{tabular}
	\end{center}
		
	\caption{Sequential block reset}
	\label{fig:ProcRst}
\end{figure}

\subsection{(*) One Statement per Line}

Although the language allows you to write more then one statement per
line (separated by \texttt{;}) it is not advisable, because finding
mistakes in your code is complicated. This is due to the fact that a
compiler reference to a line number is no more unique, for a single
statement.

\subsection{(x) Finite State Machines}

There is a recommended code structure for finite state machines. It
splits the functionality into two processes. Therefore, it is easier
to keep an overview and to combine Moore and Mealy designs in one
state machine. In order to have a well coded state machine, you write
it in three segments (declarative part and two main processes).
\begin{itemize}
\item You need to declare a signal which holds your current state
  first. Because the code readibility is better when using names
  instead of numbers for your states, using a symbolic encoded state
  signal is recommended. You can define encoding of these states if
  you want it and it is also possible to change the encoding later,
  without much effort. Figure \ref{FSMDec} shows how to declare such a
  signal.
\item The conditional state transition are all in one synchronous
  process. According to the example in figure \ref{FSMState}, for each
  state you can define conditions and a way of state changing by
  writing simple ``if'' or ``case'' statements and letting them assign
  the new state to the state signal.
\item Very similar to the first process is the one for generating
  output signals. You can either directly assign your output signals
  or you can make them not only dependent on the state, but also on
  further conditions. This is the way how you can mix Moore and Mealy
  design into one state machine. Figure \ref{FSMOut} shows a template
  for this process. You should always have ``when others'' in the case
  statement, which handles the possibility that the state machine
  might end up in a dead state.
\end{itemize}

\begin{figure}[htb]
	\begin{lstlisting}
-- SYMBOLIC ENCODED state machine: s_MY_STATE
-- ===========================================
type t_my_state is (IDLE, STATE1, ... );
-- Add these two lines to force the encoding of the state machine by the synthesis tool
-- e.g., if you need the state encoding on a top level port
-- attribute ENUM_ENCODING : STRING;
-- attribute ENUM_ENCODING of t_my_state : type is "000 001 ...";
signal s_my_state : t_my_state; -- current state
	\end{lstlisting}
	\caption{Declarations for a finite state machine}
	\label{FSMDec}
\end{figure}

\begin{figure}[htb]	
	\begin{lstlisting}
--=============================================================================
-- Begin of My Finite State Machine
-- (state transitions)
--=============================================================================
-- read:  clk_i, s_reset_n
-- write: 
-- r/w:   s_my_state
p_my_FSM_state: process (clk_i)
begin
  -- state transitions are always synchronous to the clock
  if (clk_i'event and clk_i = '1') then  
    -- on synchronous reset in any state we jump to the idle state
    if (s_reset_n = '0') then
      s_my_state <= IDLE;
    else   -- there is no reset
      case s_my_state is

        -- state "IDLE"
        when IDLE =>
          -- conditional state transitions

        -- state "STATE1"
        when STATE1 =>   
        ...

        -- all the other states (not defined)
        when others =>
          -- jump to save state (ERROR?!)
          s_my_state <= IDLE;
        end case;
     end if;
  end if;
end process p_my_FSM_state;                  
	\end{lstlisting}
	\caption{State transitions for a finite state machine}
	\label{FSMState}
\end{figure}

\begin{figure}[htb]	
	\begin{lstlisting}
--=============================================================================
-- Begin of My Finite State Machine
-- (output generation)
--=============================================================================
-- read:  s_my_state
-- write: 
-- r/w:   
p_my_FSM_output: process (s_my_state)
begin       
  case s_my_state is
   
    -- state "IDLE"
    when IDLE =>
      -- set output signals
   		
    -- state "STATE1"
    when STATE1 =>
    ...
         
    -- all the other states (not defined)
    when others =>
      null;         
  end case;  
end process p_my_FSM_output;
	\end{lstlisting}
	\caption{Output generation for a finite state machine}
	\label{FSMOut}
\end{figure}

%\subsection{(x) Avoid Three-State Signals}
%\subsection{(x) Path Routing Through Units}


\subsection{(o) Input Synchronisation}

If you are going to use a synchronous design, it is highly recommended
to use a chain of flip-flops to synchronise all asynchronous input
ports. This avoids metastability and/or spikes on these
signals. Figure \ref{fig:DBuffer} shows some code segments which you
might want to use to get around these problems.


\begin{figure}[htbp]
	\begin{lstlisting}
--=============================================================================
-- Entity declaration for double buffer
--=============================================================================
entity double_buffer is
   generic (
     g_DEFAULT : in  std_logic := 0 -- reset value for internal buffers
   );   
   port (
     clk_i     : in  std_logic; -- buffer clock
     reset_n_i : in  std_logic; -- reset for internal buffers
     input_i   : in  std_logic; -- input signal
     output_o  : out std_logic  -- double buffered output signal
   );
end entity double_buffer;
\end{lstlisting}
\dots
\begin{lstlisting}
--=============================================================================
-- architecture declaration
--=============================================================================
architecture rtl of double_buffer is

signal s_buff1, s_buff2: std_logic; -- internal signal buffers (stage 1 and 2)
\end{lstlisting}
\dots
\begin{lstlisting}
--=============================================================================
-- Begin of double buffer
--=============================================================================
-- read:  clk_i, reset_n_i, input_i, g_DEFAULT
-- write: output_o
-- r/w:   s_buff1, s_buff2
p_buffer: process (clk_i)
begin
  if (clk_i'event and clk_i = '1') then
    if reset_n_i = '0' then
      -- reset all internal buffers to default value
      s_buff1 <= g_DEFAULT;
      s_buff2 <= g_DEFAULT;
      output_o <= g_DEFAULT;
    else
      -- propagate signal through buffers (delay = 3 cycles)
      s_buff1 <= input_i;
      s_buff2 <= s_buff1;
      output_o <= s_buff2;
    end if;
  end if;
end process p_buffer;
	\end{lstlisting}
	
	\caption{Code segments for a double buffer}
	\label{fig:DBuffer}
\end{figure}

\subsection{(o) One-tick-long control signals}
Control signals like "data ready" or "reset" which are 1-tick long
leave no doubt as to when things are happening. The synchronous edge
detector circuit is very handy to generate 1-tick-long signals from
edges. Figure \ref{fig:edge_detect} shows a modified synchroniser with
edge detection. The \emph{output\_o} signal goes to '1' for one clock
tick upon detecting a rising edge of the \emph{input\_i}
signal. Notice that the edge detector does not use the \emph{s\_buff1}
signal since it could still be subject to metastability. Edge
detection of an external signal needs a chain of at least three
flip-flops.

\begin{figure}[htbp]
	\begin{lstlisting}
--=============================================================================
-- Entity declaration for double buffer
--=============================================================================
entity double_buffer is
   generic (
     g_DEFAULT : in  std_logic := 0 -- reset value for internal buffers
   );   
   port (
     clk_i     : in  std_logic; -- buffer clock
     reset_n_i : in  std_logic; -- reset for internal buffers
     input_i   : in  std_logic; -- input signal
     output_o  : out std_logic  -- double buffered output signal
   );
end entity double_buffer;
\end{lstlisting}
\dots
\begin{lstlisting}
--=============================================================================
-- architecture declaration
--=============================================================================
architecture rtl of double_buffer is

signal s_buff1, s_buff2, s_buff3: std_logic; -- internal signal buffers (stage 1 and 2)
\end{lstlisting}
\dots
\begin{lstlisting}
--=============================================================================
-- Begin of double buffer
--=============================================================================
-- read:  clk_i, reset_n_i, input_i, g_DEFAULT
-- write: output_o
-- r/w:   s_buff1, s_buff2, s_buff3
p_buffer: process (clk_i)
begin
  if (clk_i'event and clk_i = '1') then
    if reset_n_i = '0' then
      -- reset all internal buffers to default value
      s_buff1 <= g_DEFAULT;
      s_buff2 <= g_DEFAULT;
      output_o <= g_DEFAULT;
    else
      -- propagate signal through buffers (delay = 3 cycles)
      s_buff1 <= input_i;
      s_buff2 <= s_buff1;
      s_buff3 <= s_buff2;
      output_o <= s_buff2 and not s_buff3;
    end if;
  end if;
end process p_buffer;
	\end{lstlisting}
	
	\caption{Code segments for a double buffer with edge detection}
	\label{fig:edge_detect}
\end{figure}

\subsection{(o) Operator Precedence}

Do not rely on the default operator precedence. Use brackets to
specify the intended precedence in particular, which makes your code
more readable and avoids misunderstanding.

\clearpage

\subsection{(x) The Value ``don't care''}

You should not use the value ``don't care'' because various synthesis
tools may handle it in different ways. If you want to write technology
and platform independent source code this cannot be
accepted. Otherwise you also might have troubles because the ``don't
cares'' may also lead to a mismatch between simulation results and the
synthesised hardware. This makes formal verification more difficult.

\subsection{(x) Internal Tri-State}

Generally, avoid internal tri-state signals. They introduce increased
power consumption, reliability problems (if tri-state line remains
undriven) and requirement for an analog simulator (for timing
simulation of distributed tri-state busses).

If still using it, requirements are:
\begin{itemize}
	\item clearly structured layout
	\item one hot encoded enable signal
	\item bus keeper circuits
\end{itemize}

\subsection{(*) Prefer IEEE 1076.3 over Synopsis Arithmetic Packages}

In order to avoid vendor specific implementations, the use of the IEEE
1076.3 standardised packages instead of Synopsis arithmetic packages
should be preferred.

\begin{figure}[htb]
%	\begin{center}
		\begin{lstlisting}
use ieee.numeric_std.all;     -- ieee 1076.3			
use ieee.std_logic_arith.all; -- synopsys			
		\end{lstlisting}
%	\end{center}
\end{figure}

Example of usage is conversion between integer and std\_logic\_vector.

In IEEE.numeric\_std package you can find \texttt{to\_integer (ARG:
  signed, unsigned)} function. Combining it with unsigned or signed
value of the vector, using \texttt{signed (ARG: std\_logic\_vector)}
or \texttt{unsigned (ARG: std\_logic\_vector)} will result in the
complete conversion.

Example: \texttt{to\_integer (unsigned (ARG: std\_logic\_vector))}

The other way round works with the functions \texttt{to\_unsigned
  (ARG, SIZE: natural)} and \texttt{to\_signed (ARG: integer; SIZE:
  natural)}. The full conversion is done in combination with
\texttt{std\_logic\_vector (ARG: signed, unsigned)}.

Example: \texttt{std\_logic\_vector (to\_unsigned (ARG, SIZE:
  natural))} \clearpage

\subsection{(x) Signals and Variables - Usage and Declaration}

%instead of constraining the integer you could use subtypes
Since changes of variable value are immediately adopted during a
process (opposite to signals, which are updated after the process
ends) and therefore can affect the functionality of the design,
variables should be used when it is necessary to change their value
more than once inside a single process cycle, but should not be used
as registers. In that case, use signals instead.

Do not use default values (or initialization) for signals and
variables, such an assignment can cause mismatch between synthesis and
simulation. Use reset to initialize all signals and variables.

All signals or variables of type integer should be declared
constrained, because standard is a 32-bit bus. If you don't want to
use the full range in your design this would result in unnecessary use
of resources on your hardware. Therefore, you should declare your
integer signals, ports and variables always like that:

\texttt{signal integer\_signal : integer range 0 to 15;}

\subsection{(*) Entity Port Types}

If you plan to verify a certain entity using behavioural simulation on
the one hand and gate level simulation on the other, it is necessary
to declare all I/O signals as std\_logic(\_vector). This is required
because the test bench for gate level simulations has to use bit
lines. Consequently, the verification of both simulation models via
one test bench (to avoid inconsistency) is not possible if some entity
ports are not declared using elementary bit types.

Do not use buffer type ports to read output values within the
code. Instead use type out and add another variable or signal and
assign to it the same output value. This is because buffer type ports
can't be connected to other types of ports, causing the buffer type to
propagate throughout the entire design.

%\subsection{Combinational logic}
%
%Process describing combinational logic should have a complete
% sensitivity list.
%
% All output signals and variables in a combinational process should
% have assigned a default value at the beginning of the process. This
% way you avoid synthesis of transparent latches.
%
%\begin{figure}[htb]
%	\begin{center}
%		\begin{lstlisting}
%NameComb: process(input1, input2... inputn)
%variable var1 : vartype1; -- optional
%variable var2 : vartype2; -- optional
%...
%variable varm: vartypem; -- optional
%begin
%  var1 := defaultvar1;  -- mandatory if variable declared
%  var2 := defaultvar2;  -- mandatory if variable declared
%  ...
%  varm := defaultvarm;  -- mandatory if variable declared
%  out1 <= defaultOut1;
%  out2 <= defaultOut2;
%  ...
%  outj <= defaultOutj;
%  Combinational logic (any logic not including combinational feedbacks)
%end process;
%Sequential logic
%		\end{lstlisting}
%	\end{center}
%	\caption{Combinational process template}
%	\label{fig:Combinational process template}
%\end{figure}	

\subsection{(o) Latches In Design}

The usage of latches or flip-flops depends on the clocking scheme
used. These two types of storage elements must not be used
simultaneously within one design. Avoid mixing clocking schemes and
thus use either latches or flip-flops only, whereas it is strongly
recommended to prefer flip-flops.
 
The code to instantiate a transparent latch is shown in figure
\ref{fig:latch}.

\begin{figure}[htb]
		\begin{lstlisting}
p_latch: process(en_i, data_i)
begin
  if (en_i = '1') then
    s_data <= data_i;
    -- If en_i = 0, then s_data keeps its old value,
    -- i.e. the latch is closed.
  end if;
end process p_latch;
	\end{lstlisting}
\caption{VHDL Transparent Latch Instantiation}
\label{fig:latch}
\end{figure}

\subsection{(o) VHDL Coding Standards - VHDL 93}

Do not mix VHDL syntax constructs. VHDL 93 is not fully compatible
with VHDL 87, so use VHDL 93 for the whole project.

Component declaration difference example is given in figure
\ref{fig:VHDLconstruct}.

\begin{figure}[htb]
	\begin{center}
	\begin{lstlisting}
VHDL93:				VHDL87:
component <name> is		component <name>
...				...
end component <name>;		end component;
	\end{lstlisting}
\end{center}
\caption{VHDL Coding Standards Difference}
\label{fig:VHDLconstruct}
\end{figure}

\subsection{(x) Readability, Reusability, Reliability - General Advices}

\begin{itemize}
\item Whenever you find yourself coping and pasting some code, think
  of writing a function or procedure instead.
\item Make use of constants and generics for buffer sizes, bus width
  and all other unit parameters. This provides more readability and
  reusability of the code.
\item Try to use configuration to map entities, architectures and
  components (i.\,e. to define such mapping explicitly). That way
  tracing changes between different architectures can be in a single
  file. This can be useful to change simulation from high level to low
  level architectures.
\item Define components and constants in a single package for each
  core.
\end{itemize}

\clearpage

\section{Project Definition, Design, and Verification}

\subsection{Specification}

Design behaviour should be described in a short and clear
specification, which could be written by the verification engineer,
design engineer or a third person, who should try to be as precise as
possible in top level timings and protocols. The specifications should
describe a testable design, avoiding special cases and usage of
asynchronous clock domains if they are not really necessary.

Algorithms are not described, unless they are absolutely necessary for
understanding of specifications.

Both - the verification and design engineer - should be able to arrive
to the same behaviour, starting with design specifications.

\subsection{RTL Design}

Having a clear idea of the algorithms to be used in entities is the
first prerequisite. You should implement algorithms in a way that best
case=worst case, meaning that the processing time of algorithm should
be fixed, no matter the inputs or state of process. This simplifies
verification and time dependencies between processes. Exploiting
parallelism and pipelining will increase speed of progression.

Clock boundaries should be defined and a single slow system clock
should be used for most of the logic, while other domain clocks should
only be used to clock peripherals.

Calculate memory size, the number of memory blocks and number of
registers needed. Some algorithms require less memory size, but bigger
number of memory blocks. It might be surprising when you realize that
old, well known design does not fit in a brand new FPGA with just a
few huge memory blocks.

Do not underestimate the memory size you need, but try to fit into a
single, fairly big, FPGA. If this is not enough, use external memory.

The RTL engineer should write his own testbenches as a design
tool. These testbenches are highly recommended but are not considered
as a part of the verification process.

\subsection{Verification}

\indent The objective of verification phase is to guarantee the
stability of the RTL design and its conformance with the specification
requirements. Verification includes:

\begin{itemize}
\item Signals timing and protocols.
\item Design predictability (including clock domain boundaries).
\item \unit[100]{\%} code coverage.
\end{itemize}

If any of these goals is impossible to achieve, either the RTL design
or the original specifications should be revised.

\subsection{VHDL Synthesis Guidelines}

VHDL for RTL should be as generic as possible. Stick to standard
templates for combinational blocks (figure \ref{fig:CombBlck}) and
registered blocks (figure \ref{fig:ProcRst}). Memory blocks can easily
be inferred from VHDL templates with modern synthesis tools.

\begin{figure}[htb]
	\begin{lstlisting}
	p_namecomb: process (input1, input2... inputn)
	  variable v_var1 : var1type; -- optional
	  variable v_var2 : var2type; -- optional
	  ...
	  variable v_varx : varxtype; -- optional
	  	
	begin
	  v_var1 := defaultvar1; -- mandatory if variable declared
	  v_var2 := sig2;        -- mandatory if variable declared
	  ...
	  v_varx := defaultvarx; -- mandatory if variable declared

	  ...  -- Combinational logic (any logic not including combinational feedbacks)

	  sig1   <= v_var1;
	  sig2   <= v_var2;
	  ...
	  sigx   <= v_varx;
 	end process;
 \end{lstlisting}
	
	\caption{Template for combinational blocks}
	\label{fig:CombBlck}
\end{figure}

As a general rule, a design should exist in a designer's mind before
describing it in VHDL (the 'D' stands for Description). See for
example \cite{Rus00} as a book which emphasises this approach.

\subsubsection{Instantiating IP Cores}

IP cores may accelerate your design at the first stages and synthesize
at much higher frequencies as any standard home made
design. Nevertheless, experience has shown that when the design
evolves, they often do not fully adapt to new requirements and a
custom solution needs to be implemented.

\subsubsection{Registering of Core's External I/Os}

All core I/Os should be registered, whether they are FPGA I/Os or
connect to other internal FPGA resources. It prevents long timing
paths and allows you to meet timing constraints easier. It also allows
easier verification of the entire SoC. Tri-State I/Os output enable
line should also be registered.  \clearpage

\subsubsection{Clock and Multiple Clock Domains}

Design should be fully synchronous. Avoid asynchronous logic.

Try to stick to one single system clock. This simplifies the
synchronisation and timing analysis. If you ever feel the necessity of
clocking a part of your design with an extra clock domain, reduce this
new domain to the minimum necessary. For example, if a VHDL custom CPU
requires to serialize data clocked by an external source of unknown
frequency, it makes sense to clock the serializer with the external
clock and have a fixed frequency quartz as system clock. Data exchange
should be done through a deterministic synchronization algorithm
between the CPU and the serializer\footnote{The recipes for good
  synchronisation are well known but too long to describe here. See
  for example
  \href{http://www.ohwr.org/documents/22}{http://www.ohwr.org/documents/22}}. This
will result in much faster serializer and a robust CPU.

Clocks must not be ``gated''. If your design ever requires an
internally generated clock use the FPGA clock manager.

Do not use both the rising edge and the falling edge of the same
clock. Better think of using the FPGA clock manger to multiply your
clock and distribute clock enable signals as required.

\subsubsection{Use a Standard Entity for Memory Blocks}

Keep a library with standard entity for memory blocks. If possible,
try to use a standard VHDL template. It is also good practice to use
the configuration when instantiating a memory block. In that case, if
you ever want to change technology you just have to select a new
architecture for the memory instantiation.

\subsubsection{Memory Block Partitioning}

Remember that FPGA's memory blocks are independent from each
other. When you need to accelerate your algorithms, try to exploit the
possibility of splitting your data into several independent blocks and
do parallel simultaneous accesses to the memory.

\subsection{VHDL for Simulation}

\subsubsection{Testbench Goals}

VHDL testbench goals are:
\begin{itemize}
\item Signal timing and protocol verification.
	
  Testbench should check if all inputs compliant with the
  specification are understood by the UUT (Unity Under
  Test). Testbench must also check if UUT responds safely to non
  specified timings.
\item Design predictability test (including clock domain boundaries).
	
  Whatever test pattern is UUT input, the output should conform to
  specifications. Any input not compliant with specifications should
  take the UUT to a specified known state.
\item \unit[100]{\%} code coverage.
	
  Simulation should check correctness of every meaningful VHDL code
  line. RTL VHDL should be written in such a way that every line
  corresponds to one single statement. Either the specification or the
  RTL design should be revised if \unit[100]{\%} coverage is
  unreachable.
\item Generating predictive test patterns.
\end{itemize}

\subsubsection{Writing a Testbench}

There are no hard rules for writing a testbench. Common sense is the
best friend. Nevertheless, these advices may be helpful:

\begin{itemize}
\item Be creative.
	
  You are not restricted in your coding. Feel free to use records,
  variables, signal attributes, processes and functions.
\item Base your testbench in procedures and functions.
	
  Identify basic operations in your UUT interface such us ReadData,
  WriteData etc. and write a procedure for each of them. Write
  abstract procedures based on your basic procedures to do meaningful
  tests for your UUT.
\item Keep test procedures in a separate library.
	
  It gives you the possibility to reuse code easily.
\item Write a pattern generator process for every group of signals.
\item Use a rule checker process per timing rule.
	
  A rule checker process looks at a group of signals and a timing
  rule. Normally it is a good practice to write a procedure per rule
  and instantiate it in a single process.  
\item Write your own UUT behavioural model for design predictability
  test.
\item Use non RTL constructs to speed up the design.
	
  If design specifications are good and RTL and behavioural models are
  correct, there should not be any difference between both models.
\end{itemize}

\clearpage

\section{Using Documentation Generator - \emph{doxygen}}

\emph{Doxygen} is a documentation system for several languages (in the
Hardware Timing Project, intended to be used for VHDL documentation),
which can generate an on-line documentation browser (in HTML) and/or
an off-line reference manual (in LaTeX) from a set of documented
source files. \emph{Doxygen} is available for Linux, Mac OS X and
Windows.

The operating system used to test the functionalities and
configuration of \emph{doxygen} for the present document is Windows XP
Professional, it is possible to obtain slight differences in the
outcome documentation if you are using other OS.

The installation of \emph{doxygen} is widely documented in the
project's website, please refer to \cite{DXGN} if you have any doubt.

The documentation process is divided in three steps:

\begin{enumerate}
	\item Documenting the VHDL code.
	\item Configuring \emph{doxygen}.
	\item Running \emph{doxygen} to generate the documentation.
\end{enumerate}

\subsection{Documenting the VHDL Code}

For VHDL a comment normally starts with ``\verb!--!''. \emph{doxygen}
will extract comments starting with:

\begin{itemize}
	\item \verb!--!!
	\item \verb!--!! @DOXYGEN\_COMMAND
\end{itemize}

There are only two types of comment blocks in VHDL: one line
\verb!--!! comment, representing a brief description, and multiline
\verb!--!! comment, where the \verb!--!! prefix is repeated for each
line.

\begin{figure}[htb]
	\begin{center}
		\begin{lstlisting}
----------------------------------------------------------------------------------
--! @brief Brief Description
----------------------------------------------------------------------------------
--! @details
--! Detailed Description
----------------------------------------------------------------------------------
entity my_entity is
  port (
    clk_i : in std_logic; --! in body description
  );
end entity my_entity;
	\end{lstlisting}
	\end{center}
	\caption{Types of descriptions}
	\label{fig:descript}
\end{figure}

The use of the \verb!--!! @DOXYGEN\_COMMAND will represent special
parts of the documentation, and same commands will need input
parameters to set properly their effects in the documentation.

For each code item there are three types of descriptions, as shown in
Figure \ref{fig:descript}, which together form the documentation:

\begin{itemize}
	\item Brief description
	\item Detailed description
	\item In body description
\end{itemize}

For the ``In body Description'', the comments are always located in
front of the item that is being documented with one exception -
\textbf{for ports, comment could also be placed after the item and it
  is then treated as a brief description for the port.} Whenever the
code is commented without \emph{doxygen} key characters
``\verb!--!!'', it is possible to place a comment after the item (port
or not) without effects in the documentation.

The document is organized in tags and subtags:

\begin{itemize}
\item Main Page - description of the project and general information.
\item Related Pages - list of all related documentation pages,
  e.\,g. To-Do List.
\item Design Unit Members:
  \begin{itemize}
  \item Class List: a list of all design unit members with links to
    the Entities and Packages they belong to.
  \item Design Unit Members: a list of all documented class members,
    with links to the class documentation for each member
  \end{itemize}
\item Files - list of all documented files with brief descriptions.
\end{itemize}

\newpage

\subsubsection{Main Page}

Main Page purpose is customizing the index page in HTML or the first
chapter in LaTeX. The most used commands are:
\begin{itemize}
\item \textbf{@mainpage [(title)]}

  If the @mainpage command is placed in a comment block, the title
  argument is optional and replaces the default title that
  \emph{doxygen} normally generates.

\item \textbf{@section [(title)] @subsection [(title)]}

  @section and @subsection are creating (sub)sections with names
  [(title)]. The title of the subsection should be specified as the
  second argument of the command.

\item \textbf{@image [(title)] \textless file\textgreater ["caption"]
    [\textless sizeindication\textgreater =\textless
    size\textgreater]}

  This command inserts an image into the documentation. The first
  argument specifies the output format. The second argument specifies
  the file name of the image. \emph{doxygen} will look for files in
  paths (or files) that you specified after the IMAGE\_PATH tag. The
  third argument is optional and can be used to specify the caption
  that is displayed below the image.
\end{itemize}

\begin{figure}[htb]
	\begin{center}
		\begin{lstlisting}
----------------------------------------------------------------------------------
--! @mainpage My Personal Index Page
----------------------------------------------------------------------------------
--! @section
--! Section Description
--! @subsection
--! Subsection Description
--! @image html file.jpg
--! @image latex file.jpg
----------------------------------------------------------------------------------
		\end{lstlisting}
	\end{center}
	\caption{Comment block}
	\label{fig:commntblck}
\end{figure}


Comment block shown in Figure \ref{fig:commntblck} should be placed in
the main file of the project.

\subsubsection{Standard File Header}

The structure for commenting a file is detailed in the Figure
\ref{fig:filecmmnt} and used commands are given in Table \ref
{tab:cmmntcmmnd} (the command marked with ``*'' ends when a blank line
or another sectioning command is encountered also in multiline
description).

\begin{figure}[tbp!]
	\begin{center}
		\begin{lstlisting}
=============================================================================
--! @file file_name.vhd
=============================================================================
--! Standard library
library IEEE;
--! Standard packages
use IEEE.XXX.ALL;
use IEEE.XXX.ALL;
--! Specific packages
use work.XXX.ALL;
-------------------------------------------------------------------------------
-- --
-- company name, division and the name of the design --
-- --
-------------------------------------------------------------------------------
--
-- unit name: full name (shortname / entity name)
--
--! @brief <file content, behavior, purpose, special usage notes>
--! <further description>
--
--! @author <author name (email)>
--
--! @date <--\--\---->
--
--! @version <v.>
--
--! @details
--!
--! <b>Dependencies:</b>\n
--! <Entity Name,...>
--!
--! <b>References:</b>\n
--! <reference one> \n
--! <reference two>
--!
--! <b>Modified by:</b>\n
--! Author: <name>
-------------------------------------------------------------------------------
--! \n\n<b>Last changes:</b>\n
--! <date> <initials> <log>\n
--! <extended description>
-------------------------------------------------------------------------------
--! @todo <next thing to do> \n
--! <another thing to do> \n
--
-------------------------------------------------------------------------------
		\end{lstlisting}
	\end{center}
	\caption{Structure for commenting a file}
	\label{fig:filecmmnt}
\end{figure}
\clearpage In absence of command for the next comment sections, we'll
create the command appearance in the HTML and LaTex document:

\verb!--!! \verb!<b>! Dependencies:\verb!</b>\n!

\verb!--!! \verb!<b>! References:\verb!</b>\n!

\verb!--!! \verb!<b>! Modified by:\verb!</b>\n!

\verb!--!! \verb!\n\n<b>! Last changes:\verb!</b>\n!

\emph{doxygen} inherits from HTML the text tag \textless b\textgreater
\textless /b\textgreater, where the text between the tags will be
typed in bold, and the symbol \verb!\n! forces a new line.

\begin{table}[htb]
	\begin{center}
		\begin{tabular}{lll}
			\toprule
			command				& description\\
			\midrule
			@file [\textless name\textgreater]				& Indicates that a comment block contains documentation for a \\ & source file with name \textless name\textgreater.\\
			@brief*			& Starts a paragraph that serves as a brief description.\\
			@author*				& Starts a paragraph where one or more author names \\ & may be entered.\\
			@date*					& Starts a paragraph where one or more dates may be entered.\\
			@version*			& Starts a paragraph where one or more version strings \\ & may be entered.\\
			@details				& Starts the detailed description. You can also start a new \\ & paragraph (blank line), then the details command is not needed.\\
			@todo					& Starts a paragraph where a TODO item is described.  \\ & The description
will also add an item to a separate TODO list. \\ & The two instances of the description will be cross-referenced. \\ & Each item in the TODO list will be preceded by a header \\ & that indicates the origin of the item.\\
			\bottomrule
		\end{tabular}
	\end{center}
	
	\caption{Commands for commenting a file}
	\label{tab:cmmntcmmnd}
\end{table}

\newpage

\subsubsection{Comments for Entities}

As it has been said, the ports could be commented either in front of,
or after the item, but be aware that the result in the documentation
is different. The comment after the item is mandatory and represents
the brief information in the documentation. Just in case additional
information is needed, use the comment line in front of the item, it
is even possible to extend the information to several lines.

\begin{figure}[hb!] 
	\begin{center}
		\begin{lstlisting}
--============================================================================
--! Entity declaration for <long entity name of my_entity>
--============================================================================
entity my_entity is
  generic (
    g_MYGENERIC : positive := 32 --! something which has to be configurable
  );
  port (
    -- global input signals
    --! Extend description of the local bus clock
    clk_i     : in std_logic; --! local bus clock
    reset_n_i : in std_logic; --! reset =0: reset active reset =1: no reset
    -- global output signals
    led_o     : out std_logic; --! LED =0: LED on LED =1: LED off
    -- data bus(es)
    data_b    : inout std_logic_vector (7 downto 0) --! data bus
  );
end entity my_entity;		\end{lstlisting}
	\end{center}
	\caption{Comments for entities}
	\label{fig:entcmmnt}
\end{figure}
\clearpage

\subsubsection{Comments for Architectures and Processes}
The commenting in the architecture declaration follows the style of
the entity declaration. In the process statements should be used
commenting header, where the process is explained, but the statements
shouldn't be commented with the purpose of documenting.

\begin{figure}[b!]
	\begin{center}
		\begin{lstlisting}
--============================================================================
-- ! architecture declaration
--============================================================================
architecture rtl of my_entity is
   --! Extended description of local clock \n
   signal s_lclk : std_logic; --! local clock
--============================================================================
-- architecture begin
--============================================================================
begin
--============================================================================
-- Beginning of my_process
--! Process <description>
--! read: clk_i, reset_n_i \n
--! write: s_lclk \n
--! r/w: led_o \n
--============================================================================
p_my_process: process (clk_i)
begin
    if (clk_i'event and clk_i = '1') then -- synchronous process
       If reset_n_i = '0' then
          -- reset to default value
          led_o <= '1';
       else
           -- generate clock signal and LED output
           s_lclk <= not s_lclk; -- s_lclk now runs at half of clk_i
           if s_lclk = '1' then
              led_o <= '0' -- turn on LED if s_lclk is high
           end if; 
       end if;
    end if;
end process p_my_process;

end architecture rtl;
--============================================================================
-- architecture end
--============================================================================
		\end{lstlisting}
	\end{center}
	\caption{Comments for architectures and processes}
	\label{fig:proccmmnt}
\end{figure}
\clearpage

\subsection{Configuring \emph{doxygen}}

The executable doxygen is the main program that parses the sources and
generates the documentation. Optionally, the executable doxywizard can
be used, which is a graphical front-end for editing the configuration
file that is used by \emph{doxygen} and for running \emph{doxygen} in
a graphical environment.

\subsubsection{Configure \emph{doxygen} Using a \emph{doxyfile}}

\emph{doxygen} uses a configuration file to determine all of its
settings, \emph{doxyfile}. Each project should get its own
configuration file. If the \emph{doxyfile} is already provided, it can
be open (File/Open), and the settings will be loaded. These settings
are only related to the information which \emph{doxygen} will obtain
from sources.

\subsubsection{Configure \emph{doxygen} From Scratch}

\begin{itemize}
\item \textbf{Working directory}
	
  Working directory is the directory where all already commented
  sources are placed, from which we want to generate the
  documentation.
	
\item \textbf{\emph{doxygen} options}
	
  Configuration is available either via Wizard or Expert interface.
	
  \begin{itemize}
  \item Wizard interface
    
    \begin{itemize}
    \item Project:
    
    \begin{itemize}
    \item Project name = TBD
    \item Project version = TBD Versioning
    \item Source code directory = \textless source\_folder\textgreater
    \item Destination directory = \textless doc\_folder\textgreater
    \end{itemize}
    
    \item Mode:
    
    \begin{itemize}
    \item Extraction mode = Document Entities only. Include cross referenced source code in the output.
    \item Programming language = Optimized for VHDL output.
    \end{itemize}
    
   \item Output:  
   \begin{itemize} 
   \item HTML $\rightarrow$ Plain Text 
   \item LaTeX $\rightarrow$ as intermediate format for PDF.
   \end{itemize} 
    \item Diagrams: Use built-in class diagram generator
    \end{itemize}
    
    \item Expert interface
    
    \begin{itemize}
    \item Project: FULL\_PATH\_NAMES = OFF
    \item Build: GENERATE\_TODOLIST = YES
    \item Source Browser: SOURCE\_BROWSER = YES
    \item Input: IMAGE\_PATH = {path images folder}
    \item HTML:  GENERATE\_TREEVIEW = FRAME
    \end{itemize}
    
   \end{itemize}
   
\end{itemize}

\subsection{Run \emph{doxygen}}

This tag allows running documentation process, showing the
configuration, saving and visualizing the output produced by
\emph{doxygen}. Documentation HTML and LaTeX files will be placed in
defined \textless doc\_folder\textgreater.

\begin{itemize}
\item HTML
 
  The HTML folder will contain the "index.html" and all other files
  generated by \emph{doxygen}, which could be opened by Internet
  browser software to visualize the documentation.
 
\item LaTeX
 
  The LaTeX folder will contain master file "refman.tex" and the rest
  of *.tex files that compose the document.
\end{itemize}

%
%\clearpage
%
%\section{HDL release procedure}
%
%Here is a quick flow to be followed when creating a release of a new HDL version for any AB-CO-HT designed/supported boards:
%
%\begin{itemize}
%	\item For each release operation, create a release wiki page in an appropriate place within the AB-CO-HT section wiki.
%	\item Change requests.
%	
%	Bugs are grouped and classified in order of priority. Jira can be used for bug tracking during the period between releases. The end product for this phase is a change requests document posted in the release wiki page by the board designer/responsible.
%	\item Agreement about change requests.
%	
%	We discuss what bugs will be fixed in the next release. The minutes of this meeting are posted in the release wiki page, clearly indicating which bugs will be solved. There is also a schedule for the implementation and a tentative schedule for the upgrade of all boards.
%	\item Implementation and associated tests.
%	
%	Source code is kept in CVS (hierarchy shown in chapter 2), test benches as well. New features are tested both in test bench and in the lab. End product is a demo organized to show that every bug has been fixed. The demo includes both actual hardware and simulating test benches. Also, there has to be a pseudo-code review and the results are briefly documented in the release wiki page.
%	\item Integration and associated tests.
%	
%	This step only needs to happen when basic requirements have been changed, which means that the intervention was not limited to bug fixing and also included adding new features. Result of this step is briefly documented in the release wiki page and a binary file containing new bitstream is delivered to the appropriate network directory, using a versioning tool. Snapshot of the FPGA design project is delivered to CVS.
%	\item Planning for upgrade.
%	
%	All sides are contacted and it is agreed with all on a schedule for the upgrade. These arrangements are documented with their dates in the release wiki page. Appropriate announcements are sent (well in advance) to all interested parties, including Operations if needed. A reminder, one or two days before the operation, must be sent as well.
%	\item Upgrades.
%	
%	Appropriate time is reserved for the operation. Relevant stake holders must be present (for example the driver developer) so that they can act if there is any problem. For each upgrade operation (which might include many cards) an entry is added to the release wiki page, explaining the results. Version files in the upgraded front-ends are modified to reflect the current version.
%	\item Upgrade stocks.
%	
%	Stocks manager carries out the upgrade using the new testing procedures (see below) to validate that everything went OK.
%	\item Upgrade assets database, including cards in stock.
%	
%	The HDL version field must be kept up to date throughout the lifetime of each card.
%	\item Upgrade documentation.
%	
%	Each card has a ``Design Document'' and a ``User manual'' which includes testing procedures. These two documents must be updated after each HDL release.
%	\item A final comment in the release wiki page is added to announce that the release process is over and that all steps in this procedure were correctly followed. For steps not taken, explanation is added.
%\end{itemize}